/*
 * libpgvb.dll Easy Access Tool for PostgreSQL
 * written by Hiroshi Saito & Ichiro FUKUHARA 
 *
 * Copyright (c) 2001  Hiroshi Saito & Ichiro FUKUHARA 
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of the
 * author not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior
 * permission. The author makes no representations about the
 * suitability of this software for any purpose.  It is provided "as
 * is" without express or implied warranty.
 */

#include "stdafx.h"
#include "libpgvbsb.h"

static int m_conn = 0;		/* Active login =1 */
static int vbpg_rtn = 0;	/* save return code */
static int tuple = 0;		/* Active tuple count */
static int m_tuple = 0;		/* Active tuple Max count */
static char m_dlm = '\t';   /* DLIMIT */

/* GLOBAL VARIABLES */
static PGconn *conn;
static PGresult *res;

/* *******************************************************************
 *  Visual Basic Function Call
 * ******************************************************************* */
__declspec( dllexport ) long __stdcall 
VBPGlogin(unsigned char Cmd[PRMIN])
{
	/* PGconnect options host= user= passwd= dbname= */
	if(Cmd == NULL)
		vbpg_rtn = 1;
	else
		connectdb((unsigned char *)Cmd);
	return vbpg_rtn;
}
long  VBPGclose()
{
	disconnectdb();
	return 0;
}
__declspec( dllexport ) long __stdcall 
VBPGcursor(unsigned char Cmd[PRMAX])
{
    if (m_conn == 0)
		vbpg_rtn = 9;
	else
		if(Cmd == NULL)
			vbpg_rtn = 1;
		else
			doquery((unsigned char *)Cmd);
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGfetch(unsigned char Rtn[RTMAX])
{
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		if (tuple>=m_tuple)
		{
			vbpg_rtn = 1; /* EOF */
			sprintf((char *)Rtn,"");
		}
		else
			sprintf((char *)Rtn,"%s",fetch());
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGmsgget(unsigned char Rtn[PRMAX])
{
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		sprintf((char *)Rtn,"%s",PQerrorMessage(conn));
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall VBPGstatus()
{
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGexec(unsigned char Cmd[PRMAX],unsigned char Rtn[RTMAX])
{
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		if(Cmd == NULL)
			vbpg_rtn = 1;
		else
			sprintf((char *)Rtn,"%s",doexec((unsigned char *)Cmd));
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGfnames(unsigned char Rtn[RTMAX])
{
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		if (res == NULL)
		{
			vbpg_rtn = 9;
			sprintf((char *)Rtn,"It didn't reach it at last.");
		}
		else
		sprintf((char *)Rtn,"%s",dofnames());
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGvalue(long p,unsigned char Rtn[RTMAX])
{
	int fields;
	vbpg_rtn = 0;
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		if (res == NULL)
		{
			vbpg_rtn = 9;
			sprintf((char *)Rtn,"It didn't reach it at last.");
		}
		else
			if (tuple >PQntuples(res))
			{
				vbpg_rtn = 9;
				sprintf((char *)Rtn,"");
			}
			else
			{
				fields = PQnfields(res);
				if(( p < 0)||( p > fields))    
				{
					vbpg_rtn = 9;
					sprintf((char *)Rtn,"");
				}
				else
					sprintf((char *)Rtn,"%s", PQgetvalue(res,tuple-1, p-1));
			}
	
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGfname(long p,unsigned char Rtn[RTMAX])
{
	int fields;
	vbpg_rtn = 0;
    if (m_conn == 0)
	{
		vbpg_rtn = 9;
		sprintf((char *)Rtn,"Connection Closed.");
	}
	else
		if (res == NULL)
		{
			vbpg_rtn = 9;
			sprintf((char *)Rtn,"It didn't reach it at last.");
		}
		else
		{
			fields = PQnfields(res);
			if(( p < 0)||( p > fields))    
			{
				vbpg_rtn = 9;
				sprintf((char *)Rtn,"");
			}
			else
				sprintf((char *)Rtn,"%s", PQfname(res, p-1));
		}
	
	return vbpg_rtn;
}
__declspec( dllexport ) long __stdcall 
VBPGdlim(unsigned char Cmd[PRMIN])
{
	vbpg_rtn = 0;
	if(strlen((char *)Cmd) > 1)
		vbpg_rtn = 9;
	else
		sprintf((char *)&m_dlm,"%s",(unsigned char *)Cmd);
	return vbpg_rtn;
}
/* *****************************************************************
 * * libpq stdcall sub
 * ***************************************************************** */
void
connectdb(unsigned char *optis)
{
	m_conn = vbpg_rtn = 0;
    conn = PQconnectdb((char *)optis);
	
    if (PQstatus(conn) == CONNECTION_BAD)
		vbpg_rtn = 9; /* ERROR */
	else
		m_conn = 1;
}

void
disconnectdb()
{
	vbpg_rtn = 0;
    if (PQstatus(conn) == CONNECTION_BAD)
		m_conn = 0; 
	else
		PQfinish(conn);
	m_conn = 0; 
	//return conn;
}

void
doquery(unsigned char *query)
{
	vbpg_rtn = tuple = m_tuple = 0;
    if (res != NULL)
        res = NULL; 
	//PQclear(res);
    res = PQexec(conn, (char *)query);
    if  (res == NULL ||
         PQresultStatus(res) == PGRES_BAD_RESPONSE ||
         PQresultStatus(res) == PGRES_NONFATAL_ERROR ||
         PQresultStatus(res) == PGRES_FATAL_ERROR)
    {
		vbpg_rtn = 9;
	}
	else
		m_tuple = PQntuples(res);
}

char *
fetch()
{
	int fields,j,f,l;
	static char w_set[RTMAX];
	char w_flds[PRMAX];

	vbpg_rtn = f = 0;
    if (tuple >= PQntuples(res))
        return NULL;
    fields = PQnfields(res);
	for (j = 0; j < fields; j++)
	{
		sprintf((char *)&w_flds,"%s%s", PQgetvalue(res,tuple, j),(char *)&m_dlm);
		l= strlen((char *)&w_flds);
		strncpy((char *)&w_set+f,(char *)&w_flds,l);
		f +=l;
		w_set[f] = '\0';
	}
	w_set[f-1] = 0x0d;
	w_set[f++] = 0x0a;
	w_set[f] = '\0';
	tuple++;
	return (char *)w_set;
}

char *
doexec(unsigned char *query)
{
	int fields,j,f,l,i;
	static char w_set[RTMAX];
	char w_flds[PRMAX];
	doquery(query);
	if (vbpg_rtn != 0)
		return "";

	vbpg_rtn = f = 0;
    fields = PQnfields(res);
	if (fields <=0)
		return "";
	for(i=0;i<m_tuple;i++)
	{
		for (j = 0; j < fields; j++)
		{
			sprintf((char *)&w_flds,"%s%s", PQgetvalue(res, i, j),(char *)&m_dlm);
			l= strlen((char *)&w_flds);
			strncpy((char *)&w_set+f,(char *)&w_flds,l);
			f +=l;
		}
		w_set[f-1] = 0x0d;
		w_set[f++] = 0x0a;
		w_set[f] = '\0';
		tuple++;
	} /* for end */
	return (char *)w_set;
}

char *
dofnames()
{
	int fields,j,f,l;
	static char w_set[RTMAX];
	char w_flds[PRMAX];

	vbpg_rtn = f = 0;
    fields = PQnfields(res);
	if (fields <=0)
		return NULL;
	for (j = 0; j < fields; j++)
	{
		sprintf((char *)&w_flds,"%s%s", PQfname(res, j),(char *)&m_dlm);
		l= strlen((char *)&w_flds);
		strncpy((char *)&w_set+f,(char *)&w_flds,l);
		f +=l;
	}
	w_set[f-1] = 0x0d;
	w_set[f++] = 0x0a;
	w_set[f] = '\0';
	return (char *)w_set;
}
